# voss_command – Run commands on remote devices running Extreme VOSS

New in version 2.7.

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Sends arbitrary commands to an Extreme VSP device running VOSS, and returns the results read from the device. This module includes an argument that will cause the module to wait for a specific condition before returning or timing out if the condition is not met.
- This module does not support running commands in configuration mode. Please use voss_config to configure VOSS devices.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

commands
- / required

List of commands to send to the remote VOSS device. The resulting output from the command is returned. If the wait_for argument is provided, the module is not returned until the condition is satisfied or the number of retries has expired. If a command sent to the device requires answering a prompt, it is possible to pass a dict containing command, answer and prompt. Common answers are 'y' or "\r" (carriage return, must be double quotes). See examples.

interval - | Default: 1 | Configures the interval in seconds to wait between retries of the command. If the command does not pass the specified conditions, the interval indicates how long to wait before trying the command again.

match
-

Choices:
- any
- all ←

The match argument is used in conjunction with the wait_for argument to specify the match policy. Valid values are `all` or `any`. If the value is set to `all` then all conditionals in the wait_for must be satisfied. If the value is set to `any` then only one of the values must be satisfied.

retries - | Default: 10 | Specifies the number of retries a command should by tried before it is considered failed. The command is run on the target device every retry and evaluated against the wait_for conditions.
wait_for - |  | List of conditions to evaluate against the output of the command. The task will wait for each condition to be true before moving forward. If the conditional is not true within the configured number of retries, the task fails. See examples.

## Notes

Note

- Tested against VOSS 7.0.0

## Examples

    tasks:
      - name: run show sys software on remote devices
        voss_command:
          commands: show sys software

      - name: run show sys software and check to see if output contains VOSS
        voss_command:
          commands: show sys software
          wait_for: result[0] contains VOSS

      - name: run multiple commands on remote nodes
        voss_command:
          commands:
            - show sys software
            - show interfaces vlan

      - name: run multiple commands and evaluate the output
        voss_command:
          commands:
            - show sys software
            - show interfaces vlan
          wait_for:
            - result[0] contains Version
            - result[1] contains Basic

      - name: run command that requires answering a prompt
        voss_command:
          commands:
            - command: 'reset'
              prompt: 'Are you sure you want to reset the switch? (y/n)'
              answer: 'y'

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
failed_conditions list | failed | The list of conditionals that have failed Sample: ['...', '...']
stdout list | always apart from low level errors (such as action plugin) | The set of responses from the commands Sample: ['...', '...']
stdout_lines list | always apart from low level errors (such as action plugin) | The value of stdout split into a list Sample: [['...', '...'], ['...'], ['...']]

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Lindsay Hill (@LindsayHill)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.